#include "mpi.h"
#include <stdio.h>
#include <math.h>


#define MAX 3

// Bitte geben Sie IMMER drei Task an


struct MPIStruct {
		double value;
		int Pid;
};

void main(int argc, char *argv[])
{
    int myPid, i;
    int root = 0;
	int numprocs;
    
	  // Jeder Prozess hat n-Werte  Eingangswerte
	  // Es gibt k-Prozesse x n-Werte
	double dX[MAX];            

	  // Ziel pro Index den Maximalwert, in dOut
	double dY[MAX];           

	int index[MAX];
	double dmax[MAX];           

	struct MPIStruct g_in[MAX];
	struct MPIStruct g_out[MAX];

	
    MPI_Init(&argc,&argv);

	   // Anzahl der Prozesse
    MPI_Comm_size(MPI_COMM_WORLD,&numprocs);

	if ( numprocs != 3 ){
      puts("Bitte genau drei Prozesse starten");
      MPI_Finalize();
	  return;
	}
    
	   // meine eigene ID
	MPI_Comm_rank(MPI_COMM_WORLD,&myPid);
    
	for (i=0; i<MAX; i++) {
		dX[i] = 0;
		dY[i] = 0;
	}

      // Hier sollte aus einer Datei gelesen werden, pro Pid !
	switch (myPid) {
		case 0:
	    	dX[0] = 1;
	    	dX[1] = 2;
	    	dX[2] = 3;
			break;
		case 1:
	    	dX[0] = 4;
	    	dX[1] = 0;
	    	dX[2] = -1;
			break;
		case 2:
	    	dX[0] = 3;
	    	dX[1] = 6;
	    	dX[2] = 2;
			break;
	}

	  // Berechnung
	for (i=0; i<MAX; i++) {
		dY[i] = dX[i] +1;
	}

	for (i=0; i<MAX; i++) {
		g_in[i].value = dY[i];
		g_in[i].Pid = myPid;
	}
	

	// MPI_Barrier(MPI_COMM_WORLD);  // nicht notwendig, da reduce automaisch wartet

	MPI_Reduce(g_in, g_out, MAX, MPI_DOUBLE_INT, MPI_MAXLOC, root, MPI_COMM_WORLD);

	if (myPid  ==  root) {
		for (i=0; i<MAX; i++) {
			dmax[i] = g_out[i].value;
			index[i] = g_out[i].Pid;
			printf("Index: %d   Pid: %d   Maxwert: %f\n", i, index[i], dmax[i]);			
		} // for
		
	}  // if

	

    MPI_Finalize();
}

/*
Ergebnisse:

Index: 0   Pid: 1   Maxwert: 5.000000
Index: 1   Pid: 2   Maxwert: 7.000000
Index: 2   Pid: 0   Maxwert: 4.000000


*/
