#include "mpi.h"
#include <stdio.h>
#include <math.h>


void main(int argc, char *argv[])
{
    int done = 0, n, myid, numprocs, i;
    int G_sum, mysum;
    
	n = 100;
	
    MPI_Init(&argc,&argv);

	   // Anzahl der Prozesse
    MPI_Comm_size(MPI_COMM_WORLD,&numprocs);
    
	   // meine eigene ID
	MPI_Comm_rank(MPI_COMM_WORLD,&myid);
    

        // An alle Client Botschaft senden, wieviele n
			/*
				int MPI_Bcast(	
					void  *smessage,		// Sendepuffer
					int count,
					MPI_Datatype datatype,	 
					int root,				// Sender
					MPI_Comm comm			// Bereichsname
				);
			*/

	puts("Master und Client rechnen");
	G_sum = 0;
    mysum = 0;  // lokale Summe pro Client
			  // Beachte die Incrementierung    i += numprocs
    for (i = 1; i <= n; i ++)
    {
      mysum += i;
    }
			
			  // Akkumulationsoperation
			/*
				int MPI_Reduce(
					void  *sendbuf,			// sendepuffer			&mypi
					void *recvbuf,									&pi
					int count,										jeder ein double
					MPI_Datatype datatype,							Doubletyp Typ
					MPI_Op op,										Reduce-Op = Summe
					int root,				// Sender				Master ist Sender
					MPI_Comm comm			// Bereichsname			An Alle
				);	
			*/

    MPI_Barrier(MPI_COMM_WORLD);


    MPI_Reduce(&mysum, &G_sum, 1, MPI_INT, MPI_SUM, 0, MPI_COMM_WORLD);

			
		  // nur Master gibt aus
    if (myid == 0)
       printf("Master: summe %d\n", G_sum);
	else 
      printf("Client: mysum %d\n", mysum);
	

    MPI_Finalize();
}


